"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.encodeImageToStreamNode = encodeImageToStreamNode;
exports.encodeImageNode = encodeImageNode;

var _savePixels = _interopRequireDefault(require("save-pixels"));

var _ndarray = _interopRequireDefault(require("ndarray"));

var _toArrayBuffer = require("../buffer/to-array-buffer.node");

function encodeImageToStreamNode(image, options) {
  var type = options.type ? options.type.replace('image/', '') : 'jpeg';
  var pixels = (0, _ndarray.default)(image.data, [image.width, image.height, 4], [4, image.width * 4, 1], 0);
  return (0, _savePixels.default)(pixels, type, options);
}

function encodeImageNode(image, options) {
  var imageStream = encodeImageToStreamNode(image, options);
  return new Promise(function (resolve) {
    var buffers = [];
    imageStream.on('data', function (buffer) {
      return buffers.push(buffer);
    });
    imageStream.on('end', function () {
      var buffer = Buffer.concat(buffers);
      resolve((0, _toArrayBuffer.bufferToArrayBuffer)(buffer));
    });
  });
}
//# sourceMappingURL=encode-image.node.js.map